package main
import "time"
type CalendarComponent struct {
   Asset
   Uid string `json:"uid"`
}
type UniqueComponent struct {
   CalendarComponent
   Attendee []string `json:"attendee"`
   Comment []string `json:"comment"`
   Dtstamp time.Time `json:"dtstamp"`
   Organizer string `json:"organizer"`
   RequestStatuses []string `json:"requestStatuses"`
   Url string `json:"url"`
}
type RecurringComponent struct {
   UniqueComponent
   Attachements []string `json:"attachements"`
   Categories []string `json:"categories"`
   ClassType string `json:"classType"`
   Contacts []string `json:"contacts"`
   Created time.Time `json:"created"`
   Description string `json:"description"`
   LastModified time.Time `json:"lastModified"`
   Priority int32 `json:"priority"`
   Related []string `json:"related"`
   Sequence int32 `json:"sequence"`
   Summary string `json:"summary"`
}
type VAlarm struct {
   CalendarComponent
   AlarmAction string `json:"alarmAction"`
   Attachment string `json:"attachment"`
   Attendees []string `json:"attendees"`
   Description string `json:"description"`
   Duration Duration `json:"duration"`
   Repeat int32 `json:"repeat"`
   Summary string `json:"summary"`
}
type VEvent struct {
   RecurringComponent
   Dtend time.Time `json:"dtend"`
   Duration Duration `json:"duration"`
   End time.Time `json:"end"`
   IsAllDay bool `json:"isAllDay"`
   Geo GeoCoordinates `json:"geo"`
   Location string `json:"location"`
   Resources []string `json:"resources"`
   Transparency string `json:"transparency"`
   IsActive bool `json:"isActive"`
}
type VFreebusy struct {
   UniqueComponent
   Dtstart time.Time `json:"dtstart"`
   Dtend time.Time `json:"dtend"`
   Start time.Time `json:"start"`
   End time.Time `json:"end"`
}
type VJournal struct {
   RecurringComponent
}
type VTodo struct {
   RecurringComponent
   Completed time.Time `json:"completed"`
   Due time.Time `json:"due"`
   Duration Duration `json:"duration"`
   Geo GeoCoordinates `json:"geo"`
   Location string `json:"location"`
   PercentComplete int32 `json:"percentComplete"`
   Resources []string `json:"resources"`
   Todo string `json:"todo"`
}
